# AUTOGENERATED! DO NOT EDIT! File to edit: nbs/00_tests/tools/tst.remove_experiments.ipynb (unless otherwise specified).

__all__ = ['test_parse_arguments_and_remove']

# Cell
import pytest
import pandas as pd
import os
import joblib
from IPython.display import display
from dsblocks.utils.nbdev_utils import md

from hpsearch.tools.remove_experiments import *
from hpsearch.examples.dummy_experiment_manager import generate_data

# Comes from remove_experiments.ipynb, cell
def test_parse_arguments_and_remove ():
    em = generate_data ('test_parse_arguments_and_remove')

    # before
    path_experiments = em.path_experiments
    df_old = em.get_experiment_data ()
    display (df_old)

    # usage example
    parse_arguments_and_remove (['-e', '3', '7', '-p', em.manager_path, '--rename'])

    # after
    # we check that the remaining experiments do not contain number 3 or 7
    experiment_folders = os.listdir(f"{path_experiments}/experiments")
    assert len(experiment_folders)==7 and ('00007' not in experiment_folders) and ('00008' not in experiment_folders)

    # we check that neither 3 nor 7 are in the new dataframe index
    df = em.get_experiment_data ()
    assert (df.index==range(7)).all()
    assert (df.loc[3] == df_old.loc[4]).all() and (df.loc[6] == df_old.loc[8]).all()
    assert (df.loc[4] == df_old.loc[5]).all()

    em.remove_previous_experiments (parent=True)